package com.xueyi.system.version.controller;

import com.xueyi.common.core.web.result.AjaxResult;
import com.xueyi.common.core.web.validate.V_A;
import com.xueyi.common.core.web.validate.V_E;
import com.xueyi.common.log.annotation.Log;
import com.xueyi.common.log.enums.BusinessType;
import com.xueyi.common.security.annotation.RequiresPermissions;
import com.xueyi.common.web.entity.controller.BaseController;
import com.xueyi.system.api.version.domain.vo.ApkReleaseVo;
import com.xueyi.system.version.domain.dto.DmApkVersionDto;
import com.xueyi.system.version.domain.query.DmApkVersionQuery;
import com.xueyi.system.version.service.IDmApkVersionService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.io.Serializable;
import java.util.List;

/**
 * 版本管理管理 业务处理
 *
 * @author xueyi
 */
@RestController
@RequestMapping("/apkversion")
public class DmApkVersionController extends BaseController<DmApkVersionQuery, DmApkVersionDto, IDmApkVersionService> {

    /** 定义节点名称 */
    @Override
    protected String getNodeName() {
        return "版本管理" ;
    }


    @PostMapping("/api/apk_release_notify")
    @Log(title = "版本管理发布通知", businessType = BusinessType.INSERT)
    public AjaxResult apkReleaseNotify( @RequestBody ApkReleaseVo apkReleaseVo) {
        // 向数据库插入一条数据
        DmApkVersionDto apkVersion = new DmApkVersionDto();
        apkVersion.setApkVersion(apkReleaseVo.getApkVersionName());
        apkVersion.setCodeVersion(apkReleaseVo.getCodeVersionName());
        apkVersion.setReleaseTime(apkReleaseVo.getReleaseTime());
        apkVersion.setPath(apkReleaseVo.getPath());
        apkVersion.setComment(apkReleaseVo.getComment());
        return super.add(apkVersion);
    }


    /**
     * 查询版本管理列表
     */
    @Override
    @GetMapping("/list")
    @RequiresPermissions(Auth.DM_APK_VERSION_LIST)
    public AjaxResult list(DmApkVersionQuery apkVersion) {
        return super.list(apkVersion);
    }

    /**
     * 查询版本管理详细
     */
    @Override
    @GetMapping(value = "/{id}")
    @RequiresPermissions(Auth.DM_APK_VERSION_SINGLE)
    public AjaxResult getInfo(@PathVariable Serializable id) {
        return super.getInfo(id);
    }

    /**
     * 版本管理新增
     */
    @Override
    @PostMapping
    @RequiresPermissions(Auth.DM_APK_VERSION_ADD)
    @Log(title = "版本管理管理", businessType = BusinessType.INSERT)
    public AjaxResult add(@Validated({V_A.class}) @RequestBody DmApkVersionDto apkVersion) {
        return super.add(apkVersion);
    }

    /**
     * 版本管理批量删除
     */
    @Override
    @DeleteMapping("/batch/{idList}")
    @RequiresPermissions(Auth.DM_APK_VERSION_DEL)
    @Log(title = "版本管理管理", businessType = BusinessType.DELETE)
    public AjaxResult batchRemove(@PathVariable List<Long> idList) {
        return super.batchRemove(idList);
    }

    /**
     * 获取版本管理选择框列表
     */
    @Override
    @GetMapping("/option")
    public AjaxResult option() {
        return super.option();
    }

    interface Auth {
        /** 系统 - 版本管理管理 - 列表 */
        String DM_APK_VERSION_LIST = "version:apkversion:list";
        /** 系统 - 版本管理管理 - 详情 */
        String DM_APK_VERSION_SINGLE = "version:apkversion:single";
        /** 系统 - 版本管理管理 - 新增 */
        String DM_APK_VERSION_ADD = "version:apkversion:add";
        /** 系统 - 版本管理管理 - 删除 */
        String DM_APK_VERSION_DEL = "version:apkversion:delete";
    }
}
